import pytest

from refinitiv.dataplatform.content import ipa
import refinitiv.dataplatform as rdp


def test_rdp_level_scope_ok():
    assert rdp.get_repo_analytics


def test_ipa_level_scope_fail():
    with pytest.raises(AttributeError):
        assert ipa.get_repo_analytics


def test_module_level_scope_ok():
    assert ipa.repo.Definition


def test_object_level_scope_ok():
    assert ipa.FinancialContracts.get_repo_analytics
    assert ipa.FinancialContracts.get_repo_analytics_async


def test_basic_level_scope_fail():
    with pytest.raises(AttributeError):
        _ = ipa.Definition


def test_definition():
    with pytest.raises(AttributeError):
        ipa.repo._repo_definition


def test_pricing_parameters():
    with pytest.raises(AttributeError):
        ipa.repo._repo_pricing_parameters
